std::vector< bool, _Alloc > Class Template Reference
Sequences

Inherits std::_Bvector_base< _Alloc >.

## Public Types

typedef _Alloc | allocator_type
typedef _Bit_const_iterator | const_iterator
typedef const bool * | const_pointer
typedef bool | const_reference
typedef std::reverse_iterator < const_iterator > | const_reverse_iterator
typedef ptrdiff_t | difference_type
typedef _Bit_iterator | iterator
typedef _Bit_reference * | pointer
typedef _Bit_reference | reference
typedef std::reverse_iterator < iterator > | reverse_iterator
typedef size_t | size_type
typedef bool | value_type

## Public Member Functions

| vector (const allocator_type &__a)
template<typename _InputIterator >
void | _M_assign_aux (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _ForwardIterator >
void | _M_assign_aux (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
template<typename _Integer >
void | _M_assign_dispatch (_Integer __n, _Integer __val, __true_type)
template<class _InputIterator >
void | _M_assign_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
size_type | _M_check_len (size_type __n, const char *__s) const
iterator | _M_erase (iterator __pos)
iterator | _M_erase (iterator __first, iterator __last)
void | _M_erase_at_end (iterator __pos)
void | _M_fill_assign (size_t __n, bool __x)
void | _M_fill_insert (iterator __position, size_type __n, bool __x)
template<typename _Integer >
void | _M_initialize_dispatch (_Integer __n, _Integer __x, __true_type)
template<typename _InputIterator >
void | _M_initialize_dispatch (_InputIterator __first, _InputIterator __last, __false_type)
template<typename _InputIterator >
void | _M_initialize_range (_InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _ForwardIterator >
void | _M_initialize_range (_ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
void | _M_insert_aux (iterator __position, bool __x)
template<typename _Integer >
void | _M_insert_dispatch (iterator __pos, _Integer __n, _Integer __x, __true_type)
template<typename _InputIterator >
void | _M_insert_dispatch (iterator __pos, _InputIterator __first, _InputIterator __last, __false_type)
template<typename _InputIterator >
void | _M_insert_range (iterator __pos, _InputIterator __first, _InputIterator __last, std::input_iterator_tag)
template<typename _ForwardIterator >
void | _M_insert_range (iterator __position, _ForwardIterator __first, _ForwardIterator __last, std::forward_iterator_tag)
bool | _M_shrink_to_fit ()
allocator_type | get_allocator () const

## Public Attributes

| __a
| __pad0__: vector(__n
| false

## Protected Types

typedef _Alloc::template rebind< _Bit_type >::other | _Bit_alloc_type

## Protected Member Functions

_Bit_type * | _M_allocate (size_t __n)
void | _M_deallocate ()
_Bit_alloc_type & | _M_get_Bit_allocator () noexcept
const _Bit_alloc_type & | _M_get_Bit_allocator () const noexcept

## Static Protected Member Functions

static size_t | _S_nword (size_t __n)

## Protected Attributes

_Bvector_impl | _M_impl

## Friends

template<typename >
struct | hash

## Detailed Description

### template<typename _Alloc>
class std::vector< bool, _Alloc >

A specialization of vector for booleans which offers fixed time access to individual elements in any order.

Template Parameters

  _Alloc | Allocator type.

Note that vector<bool> does not actually meet the requirements for being a container. This is because the reference and pointer types are not really references and pointers to bool. See DR96 for details.

See Also
  vector for function documentation.

In some terminology a vector can be described as a dynamic C-style array, it offers fast and efficient access to individual elements in any order and saves the user from worrying about memory and size allocation. Subscripting ( ``[] ) access is also provided as with C-style arrays.

Definition at line 526 of file stl_bvector.h.

The documentation for this class was generated from the following files:

- stl_bvector.h
- vector.tcc